﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace SampleApplication
{
    /// <summary>
    /// Interaction logic for CasDataChart.xaml
    /// </summary>
    public partial class CasDataChart : Window
    {
        DispatcherTimer dispatcherTimer = null;
        private TickerBuffer tickerBuffer;
        public CasDataChart()
        {
            InitializeComponent();

            dispatcherTimer = new DispatcherTimer();

            dispatcherTimer.Tick += new EventHandler(dispatcherTimer_Tick);
            dispatcherTimer.Interval = new TimeSpan(0, 0, 1);
            dispatcherTimer.Start();

            //initializing data source with window size value specified by the trackbar
            tickerBuffer = new TickerBuffer(DataLoader.HistoricalData, 50);
            //fill the ticker buffer with historical data
            tickerBuffer.AddRecordsFromHistoricalData(tickerBuffer.WindowSize);

            this.wpfDataChart1.DataContext = this.tickerBuffer;
        }

        public void dispatcherTimer_Tick(object sender, EventArgs e)
        {
            //MessageBox.Show("timer 2 secs");
            //adding one record from the historical data to the data bound to the WPF chart component
            tickerBuffer.AddRecordsFromHistoricalData(1);
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            if (dispatcherTimer.IsEnabled)
            {
                dispatcherTimer.Stop();
                button1.Content = "StartTimer";
            }
            else
            {
                dispatcherTimer.Start();
                button1.Content = "StopTimer";
            }
        }
    }
}
