﻿using System;
using System.Collections.ObjectModel;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Charts;

namespace SampleApplication
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            // Here add data to the series

        }
    }

    public class DataCollection : ObservableCollection<DataPoint>
    {
        private static readonly Random DataGenerator = new Random();

        public DataCollection()
        {
            this.Generate();
        }


        public void Generate()
        {
            this.Clear();
            double curr = 100;
            DateTime date = new DateTime(2010, 10, 01, 12, 00, 00); //DateTime.Now;

            //int intervals = 0;
            for (int i = 0; i < 66; i++)
            {
                if (DataGenerator.NextDouble() > .5)
                {
                    curr += DataGenerator.NextDouble();
                }
                else
                {
                    curr -= DataGenerator.NextDouble();
                }
                this.Add(
                    new DataPoint
                    {
                        Date = date,
                        Index = i,
                        Label = i.ToString(),
                        Value = curr
                    });
                date = date.AddSeconds(10);

            }

        }

        public void AddData(int recordCount)
        {
            this.Clear();
            double curr = 100;
            DateTime date = new DateTime(2010, 10, 01, 12, 00, 00); //DateTime.Now;

            //int intervals = 0;
            for (int i = 0; i < recordCount; i++)
            {
                if (DataGenerator.NextDouble() > .5)
                {
                    curr += DataGenerator.NextDouble();
                }
                else
                {
                    curr -= DataGenerator.NextDouble();
                }
                this.Add(new DataPoint
                    {
                        Date = date,
                        Index = i,
                        Label = i.ToString(),
                        Value = curr
                    });
                date = date.AddSeconds(10);

            }

        }
    }
    public class DataPoint
    {
        public string Label { get; set; }
        public double Value { get; set; }
        public int Index { get; set; }
        public DateTime Date { get; set; }
    }


    //public class Strip
    //{
    //    public Strip()
    //    {
    //        _id = Guid.NewGuid();
    //        StartX = double.NaN;
    //        EndX = double.NaN;
    //        StartY = double.NaN;
    //        EndY = double.NaN;
    //    }

    //    private Strip(Guid id)
    //    {
    //        _id = id;
    //        StartX = double.NaN;
    //        EndX = double.NaN;
    //        StartY = double.NaN;
    //        EndY = double.NaN;
    //    }

    //    private Guid _id;
    //    public Guid Id
    //    {
    //        get { return _id; }
    //        private set { _id = value; }
    //    }

    //    public double StartX { get; set; }
    //    public double EndX { get; set; }
    //    public double StartY { get; set; }
    //    public double EndY { get; set; }
    //    public string Label { get; set; }

    //    public double Width
    //    {
    //        get { return Math.Abs(EndX - StartX); }
    //    }

    //    public double Height
    //    {
    //        get { return Math.Abs(EndY - StartY); }
    //    }

    //    public Brush Fill { get; set; }

    //    public DataTemplate StripTemplate { get; set; }

    //    public Strip Clone()
    //    {
    //        Strip newStripInfo = new Strip(_id);
    //        newStripInfo.StartX = StartX;
    //        newStripInfo.StartY = StartY;
    //        newStripInfo.EndX = EndX;
    //        newStripInfo.EndY = EndY;
    //        newStripInfo.Label = Label;
    //        newStripInfo.StripTemplate = StripTemplate;
    //        newStripInfo.Fill = Fill;

    //        return newStripInfo;
    //    }
    //}
    //public class StripCollection : ObservableCollection<Strip>
    //{

    //}
    //public class ChartStripsBehavior : DependencyObject
    //{
    //    public ChartStripsBehavior()
    //    {
    //        Strips = new StripCollection();
    //    }
    //    #region Properties

    //    public DataTemplate StripTemplate { get; set; }

    //    public DataTemplate HorizontalStripTemplate { get; set; }
    //    public DataTemplate VerticalStripTemplate { get; set; }

    //    public static readonly DependencyProperty StripsProperty =
    //                            DependencyProperty.Register("Strips",
    //                            typeof(StripCollection),
    //                            typeof(ChartStripsBehavior),
    //                            new PropertyMetadata(null,
    //                                (o, e) =>
    //                                    (o as ChartStripsBehavior)
    //                                    .OnStripsChanged(
    //                                    e.OldValue as StripCollection,
    //                                    e.NewValue as StripCollection)));

    //    public StripCollection Strips
    //    {
    //        get { return (StripCollection)GetValue(StripsProperty); }
    //        set { SetValue(StripsProperty, value); }
    //    }

    //    #endregion
    //    #region Methods

    //    private void GetAxes(out Axis xAxis, out Axis yAxis)
    //    {
    //        if (_owner == null)
    //        {
    //            xAxis = null;
    //            yAxis = null;
    //            return;
    //        }

    //        xAxis =
    //           (from axis in _owner.Axes
    //            where axis is NumericXAxis ||
    //            axis is CategoryXAxis ||
    //            axis is CategoryDateTimeXAxis
    //            select axis).FirstOrDefault();

    //        yAxis =
    //            (from axis in _owner.Axes
    //             where axis is NumericYAxis
    //             select axis).FirstOrDefault();
    //    }
    //    private Rect GetViewportRect(Axis axis)
    //    {
    //        double top = 0;
    //        double bottom = axis.ActualHeight;
    //        double left = 0;
    //        double right = axis.ActualWidth;

    //        double width = right - left;
    //        double height = bottom - top;

    //        if (width > 0.0 && height > 0.0)
    //        {
    //            return new Rect(left, top, width, height);
    //        }
    //        return Rect.Empty;
    //    }
    //    private void ClearExisting(Axis xAxis)
    //    {
    //        if (xAxis.RootCanvas == null)
    //        {
    //            return;
    //        }
    //        foreach (UIElement child in xAxis.RootCanvas.Children)
    //        {
    //            if (child is ContentControl &&
    //                (child as ContentControl).Content != null &&
    //                (child as ContentControl).Content is Strip)
    //            {
    //                xAxis.RootCanvas.Children.Remove(child);
    //            }
    //        }
            
    //    }
    //    private void RefreshStrips()
    //    {
    //        Axis xAxis;
    //        Axis yAxis;
    //        GetAxes(out xAxis, out yAxis);

    //        if (xAxis == null || yAxis == null || xAxis.RootCanvas == null)
    //        {
    //            return;
    //        }

    //        ClearExisting(xAxis);

    //        Rect viewport = GetViewportRect(xAxis);

    //        foreach (Strip info in Strips)
    //        {
    //            Strip toAdd = info.Clone();
    //            if (double.IsNaN(toAdd.StartX))
    //            {
    //                toAdd.StartX = viewport.Left;
    //            }
    //            else
    //            {
    //                toAdd.StartX =
    //                    xAxis.GetScaledValue(
    //                    toAdd.StartX, _owner.WindowRect, viewport);
    //            }
    //            if (double.IsNaN(toAdd.EndX))
    //            {
    //                toAdd.EndX = viewport.Right;
    //            }
    //            else
    //            {
    //                toAdd.EndX =
    //                    xAxis.GetScaledValue(
    //                    toAdd.EndX, _owner.WindowRect, viewport);
    //            }
    //            if (double.IsNaN(toAdd.StartY))
    //            {
    //                toAdd.StartY = viewport.Top;
    //            }
    //            else
    //            {
    //                toAdd.StartY =
    //                    yAxis.GetScaledValue(
    //                    toAdd.StartY, _owner.WindowRect, viewport);
    //            }
    //            if (double.IsNaN(toAdd.EndY))
    //            {
    //                toAdd.EndY = viewport.Bottom;
    //            }
    //            else
    //            {
    //                toAdd.EndY =
    //                    yAxis.GetScaledValue(
    //                    toAdd.EndY, _owner.WindowRect, viewport);
    //            }
    //            if (toAdd.StripTemplate == null)
    //            {
    //                toAdd.StripTemplate = this.StripTemplate;
    //            }

    //            if (toAdd.StripTemplate != null &&
    //                !double.IsNaN(toAdd.StartY) &&
    //                !double.IsInfinity(toAdd.StartY) &&
    //                !double.IsNaN(toAdd.StartX) &&
    //                !double.IsInfinity(toAdd.StartX))
    //            {
    //                ContentControl stripControl = new ContentControl();
    //                stripControl.ContentTemplate = toAdd.StripTemplate;
    //                stripControl.Content = toAdd;
    //                Canvas.SetLeft(stripControl, toAdd.StartX);
    //                Canvas.SetTop(stripControl, toAdd.StartY);

    //                xAxis.RootCanvas.Children.Add(stripControl);
    //            }
    //        }
    //    }



    //    #endregion
    //    #region Fields

    //    private XamDataChart _owner;


    //    #endregion
    //    #region EventHandlers
    //    private void OnStripsChanged(StripCollection oldValue, StripCollection newValue)
    //    {
    //        if (oldValue != null)
    //        {
    //            oldValue.CollectionChanged -= Strips_CollectionChanged;
    //        }

    //        if (newValue != null)
    //        {
    //            newValue.CollectionChanged += Strips_CollectionChanged;
    //        }
    //        RefreshStrips();
    //    }
    //    private void Strips_CollectionChanged(object sender, NotifyCollectionChangedEventArgs e)
    //    {
    //        RefreshStrips();
    //    }

    //    public void OnAttach(XamDataChart chart)
    //    {
    //        if (_owner != null)
    //        {
    //            OnDetach(_owner);
    //        }
    //        _owner = chart;

    //        _owner.WindowRectChanged += Owner_WindowRectChanged;
    //        _owner.SizeChanged += Owner_SizeChanged;
    //        _owner.Axes.CollectionChanged += Axes_CollectionChanged;
    //        _owner.Axes.CollectionResetting += Axes_CollectionResetting;
            
    //        RefreshStrips();
    //    }

        
    //    public void OnDetach(XamDataChart chart)
    //    {
    //        if (_owner != chart)
    //        {
    //            return;
    //        }

    //        _owner.WindowRectChanged -= Owner_WindowRectChanged;
    //        _owner.SizeChanged -= Owner_SizeChanged;
    //        _owner.Axes.CollectionChanged -= Axes_CollectionChanged;
    //        _owner.Axes.CollectionResetting -= Axes_CollectionResetting;
            
    //        Axis xAxis;
    //        Axis yAxis;
    //        GetAxes(out xAxis, out yAxis);

    //        if (xAxis == null || yAxis == null)
    //        {
    //            return;
    //        }

    //        ClearExisting(xAxis);

    //        _owner = null;
    //    }

    //    public void Axes_CollectionChanged(object sender, NotifyCollectionChangedEventArgs e)
    //    {
    //        if (e.OldItems != null)
    //        {
    //            foreach (Axis axis in e.OldItems)
    //            {
    //                axis.SizeChanged -= Axis_SizeChanged;
    //            }
    //        }
    //        if (e.NewItems != null)
    //        {
    //            foreach (Axis axis in e.NewItems)
    //            {
    //                axis.SizeChanged += Axis_SizeChanged;
    //            }
    //        }
    //        RefreshStrips();
    //    }
    //    public void Axis_SizeChanged(object sender, SizeChangedEventArgs e)
    //    {
    //        RefreshStrips();
    //    }
    //    public void Axes_CollectionResetting(object sender, EventArgs e)
    //    {
    //        foreach (Axis axis in _owner.Axes)
    //        {
    //            axis.SizeChanged -= Axis_SizeChanged;
    //        }
    //        RefreshStrips();
    //    }

        
    //    public void Owner_SizeChanged(object sender, SizeChangedEventArgs e)
    //    {
    //        RefreshStrips();
    //    }
    //    public void Owner_WindowRectChanged(object sender, Infragistics.RectChangedEventArgs e)
    //    {
    //        RefreshStrips();
    //    }

    //    #endregion
    //}
    //public class ChartBehaviors : DependencyObject
    //{
    //    public static readonly DependencyProperty ChartStripsProperty =
    //        DependencyProperty.RegisterAttached("ChartStrips",
    //        typeof(ChartStripsBehavior), typeof(ChartBehaviors),
    //        new PropertyMetadata(null,
    //            (o, e) => CursorTooltipChanged(
    //                o as XamDataChart,
    //                e.OldValue as ChartStripsBehavior,
    //                e.NewValue as ChartStripsBehavior)));

    //    public static ChartStripsBehavior GetChartStrips(DependencyObject target)
    //    {
    //        return target.GetValue(ChartStripsProperty)
    //            as ChartStripsBehavior;
    //    }

    //    public static void SetChartStrips(DependencyObject target, ChartStripsBehavior behavior)
    //    {
    //        target.SetValue(ChartStripsProperty, behavior);
    //    }

    //    private static void CursorTooltipChanged(XamDataChart chart,
    //        ChartStripsBehavior oldValue,
    //        ChartStripsBehavior newValue)
    //    {
    //        if (chart == null)
    //        {
    //            return;
    //        }
    //        if (oldValue != null)
    //        {
    //            oldValue.OnDetach(chart);
    //        }
    //        if (newValue != null)
    //        {
    //            newValue.OnAttach(chart);
    //        }
    //    }

    //}

}
